Module: Fog::Google::Shared

Instance Attribute Summary collapse

Instance Method Summary collapse

Instance Attribute Details

#api_urlObject (readonly)

Returns the value of attribute api_url


4
5
6
# File 'lib/fog/google/shared.rb', line 4

def api_url
  @api_url
end

#api_versionObject (readonly)

Returns the value of attribute api_version


4
5
6
# File 'lib/fog/google/shared.rb', line 4

def api_version
  @api_version
end

#projectObject (readonly)

Returns the value of attribute project


4
5
6
# File 'lib/fog/google/shared.rb', line 4

def project
  @project
end

Instance Method Details

#build_excon_response(body, status = 200) ⇒ Excon::Response

Builds an Excon response


152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
# File 'lib/fog/google/shared.rb', line 152

def build_excon_response(body, status = 200)
  response = Excon::Response.new(:body => body, :status => status)
  if body && body.key?("error")
    msg = "Google Cloud did not return an error message"

    if body["error"].is_a?(Hash)
      response.status = body["error"]["code"]
      if body["error"].key?("errors")
        msg = body["error"]["errors"].map { |error| error["message"] }.join(", ")
      elsif body["error"].key?("message")
        msg = body["error"]["message"]
      end
    elsif body["error"].is_a?(Array)
      msg = body["error"].map { |error| error["code"] }.join(", ")
    end

    case response.status
    when 404
      raise Fog::Errors::NotFound.new(msg)
    else
      raise Fog::Errors::Error.new(msg)
    end
  end

  response
end

#initialize_google_client(options) ⇒ Google::APIClient

Initializes the Google API Client

Options Hash (options):

  • :google_auth (Google::Auth|Signet)

    Manually created authorization to use

  • :google_client_email (String)

    A @developer.gserviceaccount.com email address to use

  • :google_key_location (String)

    The location of a pkcs12 key file

  • :google_key_string (String)

    The content of the pkcs12 key file

  • :google_json_key_location (String)

    The location of a JSON key file

  • :google_json_key_string (String)

    The content of the JSON key file

  • :google_api_scope_url (String)

    The access scope URLs

  • :app_name (String)

    The app name to set in the user agent

  • :app_version (String)

    The app version to set in the user agent

  • :google_client (Google::APIClient)

    Existing Google API Client

  • :google_client_options (Hash)

    A hash to send adition options to Google API Client


36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
# File 'lib/fog/google/shared.rb', line 36

def initialize_google_client(options)
  # NOTE: loaded here to avoid requiring this as a core Fog dependency
  begin
    # Because of how Google API gem was rewritten, we get to do all sorts
    # of funky things, like this nonsense.
    require "google/apis/monitoring_#{Fog::Google::Monitoring::GOOGLE_MONITORING_API_VERSION}"
    require "google/apis/compute_#{Fog::Compute::Google::GOOGLE_COMPUTE_API_VERSION}"
    require "google/apis/dns_#{Fog::DNS::Google::GOOGLE_DNS_API_VERSION}"
    require "google/apis/pubsub_#{Fog::Google::Pubsub::GOOGLE_PUBSUB_API_VERSION}"
    require "google/apis/resourceviews_v1beta2"
    require "google/apis/sqladmin_#{Fog::Google::SQL::GOOGLE_SQL_API_VERSION}"
    require "google/apis/storage_#{Fog::Storage::GoogleJSON::GOOGLE_STORAGE_JSON_API_VERSION}"
    require "googleauth"
  rescue LoadError => error
    Fog::Logger.error("Please install the google-api-client (>= 0.9) gem before using this provider")
    raise error
  end

  # Users can no longer provide their own clients due to rewrite of auth
  # in https://github.com/google/google-api-ruby-client/ version 0.9.
  if options[:google_client]
    raise ArgumentError.new("Deprecated argument no longer works: google_client")
  end

  # They can also no longer use pkcs12 files, because Google's new auth
  # library doesn't support them either.
  if options[:google_key_location]
    raise ArgumentError.new("Deprecated argument no longer works: google_key_location")
  end
  if options[:google_key_string]
    raise ArgumentError.new("Deprecated argument no longer works: google_key_string")
  end

  # Validate required arguments
  unless options[:google_api_scope_url]
    raise ArgumentError.new("Missing required arguments: google_api_scope_url")
  end

  application_name = "fog"
  unless options[:app_name].nil?
    application_name = "#{options[:app_name]}/#{options[:app_version] || '0.0.0'} fog"
  end

  ::Google::Apis::ClientOptions.default.application_name = application_name
  ::Google::Apis::ClientOptions.default.application_version = Fog::Google::VERSION

  auth = nil
  if options[:google_json_key_location] || options[:google_json_key_string]
    if options[:google_json_key_location]
      json_key_location = File.expand_path(options[:google_json_key_location])
      json_key = File.open(json_key_location, "r", &:read)
    else
      json_key = options[:google_json_key_string]
    end

    json_key_hash = Fog::JSON.decode(json_key)
    unless json_key_hash.key?("client_email") || json_key_hash.key?("private_key")
      raise ArgumentError.new("Invalid Google JSON key")
    end

    options[:google_client_email] = json_key_hash["client_email"]
    unless options[:google_client_email]
      raise ArgumentError.new("Missing required arguments: google_client_email")
    end

    if ENV["DEBUG"]
      ::Google::Apis.logger = ::Logger.new(::STDERR)
      ::Google::Apis.logger.level = ::Logger::DEBUG
    end

    auth = ::Google::Auth::ServiceAccountCredentials.make_creds(
      :json_key_io => StringIO.new(json_key_hash.to_json),
      :scope => options[:google_api_scope_url]
    )
  elsif options[:google_auth]
    auth = options[:google_auth]
  else
    raise ArgumentError.new(
      "Missing required arguments: google_json_key_location, "\
      "google_json_key_string or google_auth"
    )
  end

  ::Google::Apis::RequestOptions.default.authorization = auth
  auth
end

#request(api_method, parameters, body_object = nil, media = nil) ⇒ Excon::Response

Executes a request and wraps it in a result object


130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
# File 'lib/fog/google/shared.rb', line 130

def request(api_method, parameters, body_object = nil, media = nil)
  client_parms = {
    :api_method => api_method,
    :parameters => parameters
  }
  # The Google API complains when given null values for enums, so just don't pass it any null fields
  # XXX It may still balk if we have a nested object, e.g.:
  #   {:a_field => "string", :a_nested_field => { :an_empty_nested_field => nil } }
  client_parms[:body_object] = body_object.reject { |_k, v| v.nil? } if body_object
  client_parms[:media] = media if media

  result = @client.execute(client_parms)

  build_excon_response(result.body.nil? || result.body.empty? ? nil : Fog::JSON.decode(result.body), result.status)
end

#shared_initialize(project, api_version, base_url) ⇒ void

This method returns an undefined value.

Initializes shared attributes


13
14
15
16
17
# File 'lib/fog/google/shared.rb', line 13

def shared_initialize(project, api_version, base_url)
  @project = project
  @api_version = api_version
  @api_url = base_url + api_version + "/projects/"
end